package com.test.mine.docx4j;

import java.io.File;
import java.io.OutputStream;
import java.util.List;

import org.docx4j.convert.out.pdf.viaXSLFO.PdfSettings;
import org.docx4j.fonts.IdentityPlusMapper;
import org.docx4j.fonts.Mapper;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.docx4j.wml.Body;
import org.docx4j.wml.P;
import org.docx4j.wml.R;
import org.docx4j.wml.U;
import org.docx4j.wml.UnderlineEnumeration;

public class Docx4jTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		testDoc();
		createPdf();
	};
	
	
	public static void testDoc() throws Exception{
		WordprocessingMLPackage wordMLPackage = 
			WordprocessingMLPackage .load(new java.io.File("e://temp//ADL.docx"));
		MainDocumentPart documentPart = wordMLPackage.getMainDocumentPart();
		org.docx4j.wml.Document wmlDocumentEl = (org.docx4j.wml.Document) documentPart.getJaxbElement();
		Body body = wmlDocumentEl.getBody();
		String xpath = "//w:r[w:t[contains(text(),'auditFindings')]]";
		
		List<Object> list = documentPart.getJAXBNodesViaXPath(xpath, true);
		for(Object obj : list){
			List<Object>  objContent=((R)obj).getContent();
			objContent.clear();	
			objContent.add(getAuditFinding());
			objContent.add(getFindingText());
		}
	    wordMLPackage.save(new File("e://temp//ADL-new.docx"));
		
	}
	
	public static void createPdf() throws Exception{
		WordprocessingMLPackage wordMLPackage = 
			WordprocessingMLPackage .load(new java.io.File("e://temp//ADL-new.docx"));
	    Mapper fontMapper = new IdentityPlusMapper();
		wordMLPackage.setFontMapper(fontMapper);
		org.docx4j.convert.out.pdf.PdfConversion c= new org.docx4j.convert.out.pdf.viaXSLFO.Conversion(wordMLPackage);
		    OutputStream os = new java.io.FileOutputStream("e://temp//ADL-new-3.pdf");
		   c.output(os, new PdfSettings() );
	}
	
	private static P getFindingText(){
		org.docx4j.wml.ObjectFactory factory = new org.docx4j.wml.ObjectFactory();
		org.docx4j.wml.P  p = factory.createP();
		org.docx4j.wml.Text  t = factory.createText();
		t.setValue("A manual reconciliation process has been instituted.  The current reconciliation process is at the fund center level. There are written procedures for preparing the PSC 272. .  The Financial Accountants reconcile the expends vs. allots spreadsheets to balances in FETS on a monthly basis. The DCS Controller or FSSA Director of Federal funding reveiw and certify the reports.");
		org.docx4j.wml.R  run = factory.createR();
		run.getContent().add(t);
		p.getContent().add(run);
		return p;
	}
	
	
	private static P  getAuditFinding(){
		org.docx4j.wml.ObjectFactory factory = new org.docx4j.wml.ObjectFactory();
		
		org.docx4j.wml.P  p = factory.createP();
		
		org.docx4j.wml.Text  t = factory.createText();
		t.setValue("Audit Finding");
		
		org.docx4j.wml.R  run = factory.createR();
		run.getContent().add(t);
		
		p.getContent().add(run);
		
		org.docx4j.wml.RPr rpr = factory.createRPr();		
		org.docx4j.wml.BooleanDefaultTrue b = new org.docx4j.wml.BooleanDefaultTrue();
	    b.setVal(true);	    
	    rpr.setB(b);
	    
	    rpr.setU(new U(){
	    	{
	    		setVal(UnderlineEnumeration.THICK);
	    	}
	    });
	    
	    run.setRPr(rpr);
	    org.docx4j.wml.PPr ppr = factory.createPPr();	    
	    p.setPPr( ppr );
	    org.docx4j.wml.ParaRPr paraRpr = factory.createParaRPr();
	    ppr.setRPr(paraRpr);	    
	    rpr.setB(b);
	    return p;
	    
	}
}
